<!--
 * @Descripttion: 当前组件信息
 * @version: 1.0.0
 * @Author: 无尘
 * @Date: 2019-03-20 14:36:37
 * @LastEditors: 无尘
 * @LastEditTime: 2020-12-01 15:08:43
 -->
<template>
  <div class="daily-set-wrap ">
    <div class="daily-set-content border-box">
      <div class="m-b-20">
        <div role="alert" class="el-alert el-alert--info flex flex-align-start">
          <i class="el-alert__icon el-icon-info"></i>
          <div class="el-alert__content">
            <span class="el-alert__title">
              <!-- 话务任务应用下线通知：<br />
              1.【话务任务】预计将于5月下旬下线，功能将由【销售线索】替代；<br />
              2.【话务任务】下线后，【GIC后台-智能营销】中的“话务”事件也将下线，后续如需针对门店终端下发任务，请通过【GIC后台-智能营销】中的“企微任务”事件下发；<br />
              3.【话务任务】下线后，该应用中原本的“会话任务”也会下线，“不良评价回访”任务将转移至其他应用，请知悉<br /> -->
              1.预计2021年1月功能更新后将仅保留近一年数据，历史数据将清除。如需保存超过一年历史数据，请于1月前导出保存；<br />
              2.因任务数据量过大，门店视图统计数据改为每日刷新一次；<br />
              3.需要注意：话务完成详情是实时展示；完成数据统计是每日刷新，可能出现任务详情显示已完成，但是已完成数量并没有+1。这属于统计的正常情况。
            </span>
          </div>
        </div>
      </div>
      <div class="table-condition flex flex-space-between m-b-20">
        <div class="table-condition-left">
          <el-input placeholder="请输入门店名称" maxlength="50" v-model="conditionObj.searchInput" class="w-264" style="width: 264px;" @keyup.native="value => toInput(value, conditionObj.searchInput)"> <i slot="prefix" class="el-input__icon el-icon-search"></i> </el-input>
          <gic-select-group :brandId="brandId" class="m-l-10" :width="213" :selectData="conditionObj.storeGroup" @checkGroupIds="checkGroupIds"> </gic-select-group>
          <el-date-picker class="m-l-10" v-model="conditionObj.dateRange" @change="changeDate" :editable="false" :value-format="'yyyy-MM-dd'" type="daterange" align="right" unlink-panels range-separator="至" start-placeholder="开始日期" end-placeholder="结束日期"> </el-date-picker>
        </div>
        <div class="table-condition-right">
          <el-button type="danger" @click="multDel">批量删除</el-button>
          <el-button type="primary" :loading="loadingBtn" @click="exportExcel"><i class="iconfont icon-icon_yunxiazai p-r-6"></i>导出</el-button>
        </div>
      </div>

      <el-table class="select-table" ref="multipleTable" v-loading="loading" :data="tableData" tooltip-effect="dark" :style="{ width: '100%', minHeight: tableH }" @selection-change="handleSelectionChange">
        <el-table-column type="selection" width="45"> </el-table-column>
        <el-table-column width="25">
          <template slot="header" slot-scope="scope">
            <el-dropdown style="line-height: 10px; padding: 0; margin-left: -15px; transform: translateY(4px); -webkit-transform: translateY(4px);" @command="handleCommand" placement="bottom-start">
              <span class="el-dropdown-link"><i class="iconfont icongengduo"></i> </span>
              <el-dropdown-menu slot="dropdown">
                <el-dropdown-item command="0"><span :style="{ color: selectRadio == 0 ? '#2f54eb' : '#606266' }">选择当页</span></el-dropdown-item>
                <el-dropdown-item command="1"><span :style="{ color: selectRadio == 1 ? '#2f54eb' : '#606266' }">选择全部</span></el-dropdown-item>
              </el-dropdown-menu>
            </el-dropdown>
          </template>
          <template slot-scope="scope"> </template>
        </el-table-column>
        <el-table-column label="门店名称" width="120" show-overflow-tooltip>
          <template slot-scope="scope">
            <div style="width: 100%; overflow:hidden;text-overflow: ellipsis;">{{ scope.row.storeName }}</div>
          </template>
        </el-table-column>
        <el-table-column prop="" label="任务总数">
          <template slot-scope="scope">{{ scope.row.taskCount }}</template>
        </el-table-column>
        <el-table-column prop="" label="已完成(含放弃)" show-overflow-tooltip>
          <template slot-scope="scope">{{ scope.row.completedCount }}</template>
        </el-table-column>
        <el-table-column prop="" label="完成率(含放弃)" show-overflow-tooltip>
          <template slot-scope="scope">{{ scope.row.completedRate }}</template>
        </el-table-column>
        <el-table-column prop="" label="待完成" show-overflow-tooltip>
          <template slot-scope="scope">{{ scope.row.noCompletedCount }}</template>
        </el-table-column>
        <el-table-column prop="" label="逾期中" show-overflow-tooltip>
          <template slot-scope="scope">{{ scope.row.overdueCount }}</template>
        </el-table-column>
        <el-table-column label="操作">
          <template slot-scope="scope">
            <el-button type="text" @click="toDetail(scope.$index, scope.row)">查看详情</el-button>
          </template>
        </el-table-column>
      </el-table>
      <div class="block common-wrap__page text-right m-t-24" v-if="tableData.length != 0">
        <dm-pagination background @size-change="handleSizeChange" @current-change="handleCurrentChange" :current-page="currentPage" :page-sizes="[20, 40, 60, 80]" :page-size="pageSize" layout="total, sizes, prev, pager, next, jumper" :total="total"> </dm-pagination>
      </div>
    </div>
    <multiple-del :showDialog="showDialog" :detailFlag="false" @hideDialog="hideDialog" :showTip="true"> </multiple-del>
  </div>
</template>
<script>
import gicSelectGroup from '@/components/common/gic-select-group.vue';
import multipleDel from '@/components/app/cloudDaily/multiple-del.vue';
import { getRequest, postRequest, postExcel } from '@/api/api';
import { _debounce } from '@/common/js/public';
import showMsg from '@/common/js/showmsg';
import errMsg from '@/common/js/error';
export default {
  props: {
    brandId: {
      type: String,
      default() {
        return '';
      }
    },
    activeGroupId: {
      type: String,
      default() {
        return '';
      }
    }
  },
  data() {
    return {
      tableH: window.screen.availHeight - 464 - 126,
      activeTab: '1',
      activeBrand: this.brandId,
      actictiveGroup: this.activeGroupId, // 商户(品牌) groupId
      showDialog: false,
      activeId: '1',
      conditionObj: {
        tableType: '1',
        storeGroup: [],
        storeType: '',
        dateRange: []
      },
      selectRadio: 0, // 选择当页/选择全部
      loading: false,
      tableData: [],
      multipleSelection: [],
      // 分页参数
      currentPage: 1,
      pageSize: 20,
      total: 0,
      loadingBtn: false
    };
  },
  computed: {},
  methods: {
    /**
     * 选择门店分组
     */
    checkGroupIds: function(nodes) {
      const that = this;
      that.conditionObj.storeGroup = nodes;
      that.currentPage = 1;
      that.getTableList();
    },

    /** *
     * 显示选择本页 / 全部 *
     */
    handleCommand(command) {
      this.selectRadio = command;
    },

    /**
     * 输入
     */
    toInput: _debounce(function(e, value) {
      let that = this;
      that.currentPage = 1;
      that.getTableList();
    }, 500),

    /**
     * 门店类型
     */
    changeStoreType() {
      const that = this;
      that.currentPage = 1;
      that.getTableList();
    },

    /**
     *  日期
     */
    changeDate(e) {
      const that = this;
      if (!e) {
        that.conditionObj.dateRange = [];
      }
      that.currentPage = 1;
      that.getTableList();
    },

    /**
     * 表格选择
     */
    handleSelectionChange(val) {
      this.multipleSelection = val;
    },

    /**
     * 删除选的部门
     */
    delDepart(index, item) {
      const that = this;
      item.splice(index, 1);
      that.currentPage = 1;
      that.getTableList();
    },

    /**
     * 批量删除
     */
    multDel() {
      const that = this;
      if (!that.multipleSelection.length) {
        that.$message.error({
          duration: 1000,
          message: '请选择删除项'
        });
        return false;
      }
      that.showDialog = true;
    },

    /* *
     *  批量删除---弹窗关闭
     */
    hideDialog(obj) {
      const that = this;
      that.showDialog = false;
      if (!Object.keys(obj).length) {
        return false;
      }
      that.postMultDel(obj);
    },

    postMultDel(obj) {
      let that = this;
      let storeGroups = [];
      that.conditionObj.storeGroup.forEach(ele => {
        storeGroups.push(ele.storeGroupId);
      });
      if (!that.conditionObj.dateRange) {
        that.conditionObj.dateRange = [];
      }
      let para = {
        search: that.conditionObj.searchInput || '', // 搜索字段
        storeGroupIds: storeGroups.join(',') || '', // 门店分组,数组
        storeIds: that.selectRadio == 1 ? '' : that.multipleSelection.map(ele => ele.storeId).join(','), // 门店分组,数组
        storeType: that.conditionObj.storeType || '', //门店类型
        startDate: that.conditionObj.dateRange[0] || '',
        endDate: that.conditionObj.dateRange[1] || '',
        enterpriseId: that.activeBrand, // 品牌 id
        delTaskStatus: obj.delOptFlag, // 0:仅删除逾期任务，1:删除所有待完成任务
        reason: obj.reason, // 备注
        isAll: that.selectRadio // 1：当页，2：所有
        // taskType: 1 //0不良评价，1话务任务
      };
      postRequest('/haoban-app-tel-task-three-web/task/batch-del-store-task-list', para)
        .then(res => {
          let resData = res.data;
          if (resData.errorCode == 1) {
            showMsg.showmsg('删除成功', 'success');
            that.getTableList();
            return;
          }
          errMsg.errorMsg(resData);
        })
        .catch(function(error) {
          that.$message.error({
            duration: 1000,
            message: error.message
          });
        });
    },

    /**
     * 导   出
     */
    exportExcel() {
      const that = this;
      if (!that.multipleSelection.length) {
        showMsg.showmsg('请选择门店', 'warning');
        return false;
      }
      that.loadingBtn = true;
      let storeGroups = [];
      that.conditionObj.storeGroup.forEach(ele => {
        storeGroups.push(ele.storeGroupId);
      });
      let para = {
        search: that.conditionObj.searchInput || '', // 搜索字段
        storeGroupIds: storeGroups.join(',') || '', // 门店分组,数组
        storeIds: that.selectRadio == 1 ? '' : that.multipleSelection.map(ele => ele.storeId).join(','), // 门店分组,数组
        storeType: that.conditionObj.storeType || '', //门店类型
        startDate: !!that.conditionObj.dateRange ? that.conditionObj.dateRange[0] : '',
        endDate: !!that.conditionObj.dateRange ? that.conditionObj.dateRange[1] : '',
        enterpriseId: that.activeBrand, // 品牌 id
        selectType: that.selectRadio
      };
      postExcel('/haoban-app-tel-task-three-web/task/export-store-task-list', para)
        .then(res => {
          that.loadingBtn = false;
          if (!res.data) {
            errMsg.errorMsg('暂无数据');
            return false;
          }
          // let resData = res.data;
          const blob = new Blob([res.data], {
            type: 'application/vnd.ms-excel'
          });
          const fileName = `${that.tableData[0] ? that.tableData[0].storeName : ''}门店任务报表.csv`;
          const elink = document.createElement('a');
          elink.download = fileName;
          elink.style.display = 'none';
          elink.href = URL.createObjectURL(blob);
          document.body.appendChild(elink);
          elink.click();
          URL.revokeObjectURL(elink.href); // 释放URL 对象
          document.body.removeChild(elink);
          // errMsg.errorMsg(resData);
        })
        .catch(function(error) {
          that.loadingBtn = false;
          that.$message.error({
            duration: 1000,
            message: error.message
          });
        });
    },

    /**
     *  分页---页码变化
     *  @param {Number} val
     */
    handleSizeChange(val) {
      const that = this;
      that.currentPage = 1;
      that.pageSize = val;
      that.getTableList();
    },

    /**
     * 分页---当前页变化
     *  @param {Number} val
     */
    handleCurrentChange(val) {
      const that = this;
      that.currentPage = val;
      // let fullPath = that.$route.fullPath;
      that.getTableList();
    },

    /**
     * 弹窗显示事件
     */
    showDialogLayer(type, selData) {
      const that = this;
      that.selectType = type;
      that.changed = type;
      that.defaultStoreList = selData;
      that.storeTreeSet = {
        dialogVisible: true,
        isSingle: false,
        isSelectPerson: false
      };
    },

    /**
     * 处理已选部门
     */
    handleSelectedList(group) {
      let that = this;
      // type:	1:员工,2:部门,3:门店;
      that.conditionObj.storeGroup = group;
      that.getTableList();
    },

    /**
     * 查看详情
     */
    toDetail(index, row) {
      let that = this;
      that.$router.push(`taskDetail?storeId=${row.storeId}`);
    },

    /**
     * 获取列表数据
     */
    getTableList(val) {
      const that = this;
      that.loading = true;
      let storeGroups = [];
      that.conditionObj.storeGroup.forEach(ele => {
        storeGroups.push(ele.storeGroupId);
      });
      if (!that.conditionObj.dateRange) {
        that.conditionObj.dateRange = [];
      }
      let para = {
        search: that.conditionObj.searchInput || '', // 搜索字段
        storeGroupIds: storeGroups.join(',') || '', // 门店分组,分组
        storeType: that.conditionObj.storeType || '', //门店类型
        startDate: that.conditionObj.dateRange[0] || '',
        endDate: that.conditionObj.dateRange[1] || '',
        pageNum: that.currentPage, // 当前页
        pageSize: that.pageSize, // 一页显示个数
        enterpriseId: that.activeBrand
        // taskType: 1 //0不良评价，1话务任务
      };
      getRequest('/haoban-app-tel-task-three-web/task/store-task-list', para)
        .then(res => {
          let resData = res.data;
          that.loading = false;
          if (resData.errorCode == 1) {
            that.tableData = resData.result.list || [];
            that.total = resData.result.pageInfo.total;
            return false;
          }
          errMsg.errorMsg(resData);
        })
        .catch(function(error) {
          that.loading = false;
          that.$message.error({
            duration: 1000,
            message: error.message
          });
        });
    },
    initDataRange() {
      let date = new Date();
      let nowTime = date.getTime() - 90 * 24 * 3600 * 1000;
      let year = date.getFullYear();
      let month = date.getMonth() + 1;
      let day = date.getDate() < 10 ? '0' + date.getDate() : date.getDate();
      let newMonth = month < 10 ? '0' + month : month;

      let startDate = new Date(nowTime);
      let startYear = startDate.getFullYear();
      let startMonth = startDate.getMonth() + 1;
      let startDay = startDate.getDate() < 10 ? '0' + startDate.getDate() : startDate.getDate();
      let startNewMonth = startMonth < 10 ? '0' + startMonth : startMonth;
      return [`${startYear}-${startNewMonth}-${startDay}`, `${year}-${newMonth}-${day}`];
    }
  },
  watch: {
    brandId: function(newData, oldData) {
      let that = this;
      if (!!newData) {
        that.activeBrand = newData;
        that.getTableList();
      }
    },
    activeGroupId: function(newData, oldData) {
      let that = this;
      if (!!newData) {
        that.activeGroup = newData;
      }
    }
  },
  mounted() {
    const that = this;
    that.conditionObj.dateRange = that.initDataRange();
    document.documentElement.style.backgroundColor = '#f0f2f5';
    that.activeBrand = that.brandId;
    if (!!this.brandId) {
      that.$nextTick(() => {
        that.getTableList();
      });
    }
  },
  destroyed() {
    document.documentElement.style.backgroundColor = '#fff';
  },
  components: {
    gicSelectGroup,
    multipleDel
  }
};
</script>
<style type="text/scss" lang="scss" scoped>
.color-c0c4cc {
  display: inline-block;
  line-height: 34px;
  padding-left: 10px;
  color: #c0c4cc;
}
.condition-tips {
  display: inline-block;
  vertical-align: middle;
  line-height: 32px;
}
.el-alert--info {
  width: 100%;
  font-size: 14px;
  color: #606266;
  background: rgba(240, 245, 255, 1);
  border-radius: 2px;
  border: 1px solid rgba(133, 165, 255, 1);
  .el-icon-info {
    width: 12px;
    font-size: 12px;
    color: #2f54eb;
    align-self: flex-start;
    padding-top: 3px;
  }
}
.daily-set-wrap {
  height: 100%;
  .daily-set-content {
    padding: 20px;
    .table-condition-left {
      font-size: 0;
    }
  }
  .depart-item-content {
    width: 213px;
    height: 32px;
    overflow: hidden;
    white-space: nowrap;
    border-radius: 4px;
    border: 1px solid #dcdfe6;
    cursor: pointer;
  }
  .item-cell-select {
    >>> .el-select__tags {
      white-space: nowrap;
      overflow: hidden;
    }
  }
  .depart-cell {
    position: relative;
    margin: 0 24px 24px 0;
    .el-icon-circle-close {
      position: absolute;
      top: -10px;
      right: -10px;
      font-size: 16px;
      color: #808995;
      cursor: pointer;
    }
  }
}
</style>
